#ifdef GL_ES
precision mediump float;
#endif

uniform vec2 size;

varying vec2 v_texCoord;

vec4 mix()
{
	float scale = 5.0;
	float offset_x = scale / size.x;
	float offset_y = scale / size.y;

	float	weight[] = {0.2f, 0.4f, 0.4f};
	int		count[] = {1, 8, 16};

	vec4 color = vec4(0, 0, 0, 0);

	int outline = 2;
	for (int i = -outline; i <= outline; i++) {
		for (int j = -outline; j <= outline; j++) {
			int layer = max(abs(i), abs(j));
			float wei = weight[layer] / count[layer];

			color += texture2D(CC_Texture0, vec2(v_texCoord.x + offset_x * i, v_texCoord.y + offset_y * j)) * wei;
		}
	}
	return color;
}

void main()
{
	gl_FragColor = mix();
	// gl_FragColor = GradualColor(vec4(1.0, 0, 0, 1.0));
}